
dim shared alphabet(0 to 4, 0 to 4) as uinteger = {_
  {&h03FABCBA, &h0077FCFF, &h0073FCFF, &h0053FEFF, &h02C6BCBB},_
  {&h020FC17F, &h01803000, &h000684B3, &h02E00000, &h02154B5E},_
  {&h0A0FC37F, &h08080500, &h0BCEB5B3, &h01080100, &h0B3D4B5E},_
  {&h020FC77F, &h03801000, &h000780C3, &h00E02400, &h02154B5E},_
  {&h03FC32B0, &h0073F28F, &h007172C9, &h005772CF, &h02C23C91}_
}

type punkte
  as const integer breite = 11 * 5 + 12, hoehe = 1 * 5 + 2
  as const integer u = 4
  as const integer farbe1 = 0, farbe2 = &h202020, farbe3 = &hABCDEF
  declare sub zeichnen
  declare sub zeichnen(i as integer, ax as integer, ay as integer)
  declare sub zeichnen(s as string)
end type

dim p as punkte
p.zeichnen
p.zeichnen("HALLO WELT!")
sleep

sub punkte.zeichnen
  screenres (2 * breite + 1) * u, (2 * hoehe + 1) * u, 32
  color , farbe1
  cls
  dim as integer xf, yf
  for x as integer = 0 to breite - 1
    for y as integer = 0 to hoehe - 1
      xf = 2 * u * x + u
      yf = 2 * u * y + u
      line(xf, yf)-(xf + u, yf + u), farbe2, bf
    next y
  next x
end sub

sub punkte.zeichnen(i as integer, ax as integer, ay as integer)
  dim as integer xf, yf
  if (i < 0) or (i > 31) then i = 0
  for x as integer = 0 to 4
    for y as integer = 0 to 4
      if (alphabet(x, y) and (1 shl i)) > 0 then
        xf = 2 * u * (ax + x) + u
        yf = 2 * u * (ay + y) + u
        line(xf, yf)-(xf + u, yf + u), farbe3, bf
      end if
    next y
  next x
end sub

sub punkte.zeichnen(s as string)
  const chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ !"
  dim index as integer
  if len(s) > 11 then s = left(s, 11)
  for i as integer = 0 to len(s) - 1
    index = instr(chars, chr(s[i])) - 1
    zeichnen(index, 6 * i + 1, 1)
  next i
end sub
